#################################################
###SET OF FUNCTION CREATED TO ONE DIMENSIONAL ###
#############################KERNEL ESTIMATIONS##
#################################################
######################JUL-2019################################
################################ESTIMATION AND VISUALIZATION##
##############################################################

#FUNCTION TO INTERPOLATE LOCATION BETWEEN SUCESSIVE LOCATIONS ALONG THE SPATIALLINE
interpol=function(line,n=50,rioOne=T){
lines=riverline@lines[[1]]@Lines[[1]]@coords
newline=matrix(,,)[-1,]
for(i in c(1:nrow(lines))[-nrow(lines)]){
x=seq(lines[i,1],lines[i+1,1],l=n)
y=seq(lines[i,2],lines[i+1,2],l=n)
newline=rbind(newline,cbind(x,y))
}
return(SpatialLines(list(Lines(list(Line(newline)),ID=1)),proj4string=CRS(proj4string(line))))
}


#FUNCTION FOR RELOCATE THE LOCATION IN RIVER
newloc1D=function(point,line,ids){
loc2=matrix(,,2)[-1,]
lid=unique(ids)
lines=SpatialPoints(line@lines[[1]]@Lines[[1]]@coords,proj4string=CRS(proj4string(line)))
for(i in 1:length(lid)){
temp=point[point$id==lid[i],]
loc=matrix(,,2)[-1,]
	for(j in 1:length(temp)){
	loc=rbind(loc,lines[which(gDistance(lines,temp[j,],byid=T)==min(gDistance(lines,temp[j,],byid=T))),]@coords)
	}
colnames(loc)=c("long","lat")
rownames(loc)=1:nrow(loc)
loc=data.frame(loc,id=lid[i])
loc2=rbind(loc2,loc)
}
return(SpatialPointsDataFrame(loc2[,1:2],data=data.frame(id=loc2$id)))
}

#FUNCTION FOR CREATING A RIVER IN A ONE_DIMENSIONAL ARRAY
rioOne=function(river){
rioarray=as.numeric();rioarray[1]=0
lines=SpatialPoints(river@lines[[1]]@Lines[[1]]@coords,proj4string=CRS(proj4string(river)))
	for(i in c(1:length(lines))[-length(lines)]){
	rioarray[i+1]=gDistance(lines[i,],lines[i+1,])
	}
return(data.frame(array1D=cumsum(rioarray),lines@coords))
}

#FUNCTION FOR SORTING LOCATIONS BY ID 
sort_loc=function(loc,line,ids){
id=unique(ids)
lines=SpatialPoints(line@lines[[1]]@Lines[[1]]@coords,proj4string=CRS(proj4string(line)))
l=matrix(,,2)[-1,]
for(i in 1:length(id)){
temp=loc[loc$id==id[i],]
ref=paste(lines@coords[,1],lines@coords[,2])
busca=paste(temp@coords[,1],temp@coords[,2])
find=lines@coords[sort(match(busca,ref)),]
rownames(find)=1:nrow(find)
sort=data.frame(find,id=id[i])
l=rbind(l,sort)
}
ll=SpatialPointsDataFrame(l[,1:2],data=data.frame(id=l$id))
return(ll)
}

#FUNCTION FOR TRANFORMING BI-DIMENSIONAL RELOCATIONS TO ONE-DIMENSIONAL ARRAY
oneD=function(loc,river,ids){
id=unique(ids)
locOneD=matrix(,,2)[-1,]
line=SpatialPoints(river@lines[[1]]@Lines[[1]]@coords,proj4string=CRS(proj4string(river)))
along=matrix(,,)[-1,]
for(i in 1:length(id)){
position=as.numeric()
temp=loc[loc$id==id[i],]
	for(j in 1:length(temp)){
	busca=paste(temp[j,]@coords[1],temp[j,]@coords[2])
	ref=paste(line@coords[,1],line@coords[,2])
	segment=SpatialLines(list(Lines(Line(line[1:match(busca,ref),]),ID="1")),proj4string=CRS(proj4string(river)))
	position[j]=ifelse(nrow(coordinates(segment)[[1]][[1]])>1,gLength(segment),0)
	}
position=data.frame(id=id[i],oneD=position,temp@coords)
along=rbind(along,position)
}
return(along)
}

#FUNCTION TO ESTIMATE ONE-DIMENSIONAL KERNEL
kd1=function(list,h=20,...){lapply(list,function(x){kde(x$oneD,h=h,...)})}


#FUNCTION TO CUT KERNEL ISOPLETHS
kiso=function(kernel,iso=95){
k=list()
for(i in 1:length(kernel)){
temp=data.frame(order=1:length(kernel[[i]]$estimate),eval.points=kernel[[i]]$eval.points,estimate=kernel[[i]]$estimate,
iso=kernel[[i]]$estimate/sum(kernel[[i]]$estimate))
temp=temp[order(temp$estimate,decreasing=T),]
temp$cum=cumsum(temp$iso)
onek=temp[temp$cum<iso/100,]
k[[i]]=temp[order(onek$order),]
}
names(k)=names(kernel)
return(k)
}

#LINE-RANGE OBJECT
linerange=function(iso,river,riverOne){
line=SpatialPoints(river@lines[[1]]@Lines[[1]]@coords,proj4string=CRS(proj4string(river)))
ncores=lapply(iso,function(x){length(which((diff(x$order)>1)))+1})
split=lapply(iso,function(x){which(diff(x$order)>1)})
split[ncores==1]=NA
ids=names(iso)
k1d=list()
for(i in 1:length(split)){
	if(is.na(split[[i]][1])){
	locNA=matrix(,,)[-1,]
		for(j in 1:nrow(iso[[i]])){
		min=which(abs(riverOne$array1D-iso[[i]]$eval.points[j])==min(abs(iso[[i]]$eval.points[j]-riverOne$array1D)))[1]
		locNA=rbind(locNA,riverOne[min,-1])
		}
	segment=SpatialLines(list(Lines(Line(locNA),ID="1")),proj4string=CRS(proj4string(river)))
	}
	if(!is.na(split[[i]][1])){
	loc=matrix(,,)[-1,]
		for(j in 1:nrow(iso[[i]])){
		min=which(abs(riverOne$array1D-iso[[i]]$eval.points[j])==min(abs(iso[[i]]$eval.points[j]-riverOne$array1D)))[1]
		loc=rbind(loc,riverOne[min,-1])
		}
		segment=SpatialLines(list(Lines(Line(loc[1:split[[i]][1],]),ID="1")),proj4string=CRS(proj4string(river)))
		cut=c(split[[i]],nrow(loc))

		for(z in c(1:length(cut))[-length(cut)]){
		segment=spRbind(segment,SpatialLines(list(Lines(Line(loc[(cut[[z]]+1):cut[[z+1]],]),ID=z+1)),proj4string=CRS(proj4string(river))))
		}
	}
k1d[[i]]=segment
lrange=lapply(k1d,gLength,byid=T)
lrtotal=lapply(lrange,sum)
}
names(k1d)=names(lrtotal)=names(lrange)=names(iso)
return(list(lrange=lrtotal,lseg=lrange,lines=k1d))
}

#FUCTION TO CALCULATE THE RIVER LENGTH USING EXTREME RELOCATIONS
line_extreme=function(linear_relocation,ids){
split=split(linear_relocation,ids)
lin=lapply(split,function(x){diff(range(x$oneD))})
return(unlist(lin))
}

#FUNCTION FOR LINERANGE OVERLAP
lrangeOver=function(lrange){
over=matrix(NA,length(lrange),length(lrange))
colnames(over)=rownames(over)=names(lrange)
for(i in 1:length(lrange)){
	for(j in 1:length(lrange)){
	int=gIntersection(lrange[[i]],lrange[[j]])
	if(is.null(int)){over[i,j]=0}
	if(!is.null(int)){over[i,j]=gLength(int)/gLength(lrange[[i]])}
	}
}
return(over)
}

#FUNCTION FOR KERNEL 2D CUTTING RIVER
kd2=function(coo,river,h="href",iso=95){
	if(h=="hmean"){
	k=kernelUD(coo)
	h=mean(unlist(lapply(k,function(x){x@h$h})))
	}
k=kernelUD(coo,h,same4all=T,grid=600)
pol=getverticeshr(k,iso)
lrange=gIntersection(pol,river,byid=T)
pol50=getverticeshr(k,50)
lrange50=gIntersection(pol50,river,byid=T)
if(class(river)=="SpatialPolygons"){area=gArea(lrange,byid=T)/10^4}#;names(area)=names(k)
if(class(river)=="SpatialLines"){area=gLength(lrange,byid=T)};#names(area)=names(k)
resul=list(lrange=area,spatial=lrange,spatial50=lrange50)
class(resul)="lrange"
return(resul)
}

##FUNCTION FOR PLOTING LINEAR RANGES
plot.lrange=function(lrange,river,earth=F,all=T,coo=NULL){
lrange95=lrange$spatial
lrange50=lrange$spatial50
if(all==T){	
par(mfrow=c(ceiling(sqrt(length(lrange95))),ceiling(sqrt(length(lrange95)))),mar=c(0,0,0,0))
	for(i in 1:length(lrange95)){
		if(earth==T){
			if(class(lrange95)=="SpatialPolygons"){
			plot(river);plot.map(zoom=15,add=T)
			plot(river,col=4,border=4,axes=T,xaxt="n",yaxt="n",add=T)
			}
			if(class(lrange95)=="SpatialLines"){
			plot(river);plot.map(zoom=15,add=T)
			plot(river,col=4,border=NA,axes=T,xaxt="n",yaxt="n",add=T,lwd=3)
			}
		}
		if(earth==F){
			if(class(lrange95)=="SpatialPolygons"){		
			plot(river,col=4,border=NA,axes=T,xaxt="n",yaxt="n",add=T)
			}
			if(class(lrange95)=="SpatialLines"){		
			plot(river,col=4,border=NA,axes=T,xaxt="n",yaxt="n",lwd=3,add=T)
			}
		}
		if(class(lrange95)=="SpatialPolygons"){
		plot(lrange95[i],col=1,add=T,border=1)
		plot(lrange50[i],col=2,add=T,border=2)
		}
		if(class(lrange95)=="SpatialLines"){
		plot(lrange95[i],col=1,add=T,lwd=3)
		plot(lrange50[i],col=2,add=T,lwd=3)
		}
		if(!is.null(coo)){
		ids=unique(coo$id)
		plot(coo[coo$id==ids[i],],add=T,col="white",pch=21)
		}
	}
}
if(all!=T){
	if(class(lrange95)=="SpatialPolygons"){id=paste(all,1)}
	if(class(lrange95)=="SpatialLines"){id=paste(all,0)}
	if(earth==T){
		if(class(lrange95)=="SpatialPolygons"){
		plot(river);plot.map(zoom=15,add=T)
		plot(river,col=4,border=NA,axes=T,xaxt="n",yaxt="n",add=T)
		}
		if(class(lrange95)=="SpatialLines"){
		plot(river);plot.map(zoom=15,add=T)
		plot(river,border=NA,col=4,axes=T,xaxt="n",yaxt="n",add=T,lwd=3)
		}
	}
	if(earth==F){
		if(class(lrange95)=="SpatialPolygons"){
		plot(river,col=4,border=NA,axes=T,xaxt="n",yaxt="n",add=T)
		}
		if(class(lrange95)=="SpatialLines"){
		plot(river,col="gray30",border=NA,axes=T,xaxt="n",yaxt="n",lwd=3,ad=T)
		}
	}
	if(class(lrange95)=="SpatialPolygons"){
	plot(lrange95[id],col=1,add=T,border=1)
	plot(lrange50[id],col=2,add=T,border=2)
	}
	if(class(lrange95)=="SpatialLines"){
	plot(lrange95[id],col=1,add=T,lwd=3)
	plot(lrange50[id],col=2,add=T,lwd=3)
	}
	if(!is.null(coo)){
	plot(coo[coo$id==all,],add=T,col="white",pch=21)
	}
}
}

plot.ext=function(){

}

